package me.Demon.DemonDeathEvent;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.PlayerDeathEvent;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.scheduler.BukkitRunnable;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

public class Main extends JavaPlugin implements Listener {

    public  static Main plugin;
    public static List<String> listWorld = new ArrayList<>();
    public static List<String> BlockWorld = new ArrayList<>();

    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        Bukkit.getPluginManager().registerEvents( this, this );
        listWorld.addAll(getConfig().getConfigurationSection("WorldSpawn").getKeys(false));
        BlockWorld.addAll(getConfig().getStringList("BlockWorld"));
        Bukkit.getConsoleSender().sendMessage("§b[DemonDeathEvent] §a插件成功载入Sever！");
        Bukkit.getConsoleSender().sendMessage("§b[DemonDeathEvent] §a妖魂QQ:1763917516");
    }
    public void onDisable(){
        Bukkit.getConsoleSender().sendMessage("§b[DemonDeathEvent] §c插件已正常关闭！");
    }

    public boolean onCommand(CommandSender sender, Command cmd, String Command, String[] args) {
        if (Command.equalsIgnoreCase( "setrespawn" ) && sender.isOp() && (sender instanceof Player)) {
            Player p = (Player)sender;
            String worldName = p.getWorld().getName();
            String str = "WorldSpawn." + worldName + ".";
            getConfig().set(str + "world", p.getLocation().getWorld().getName());
            getConfig().set(str + "x", p.getLocation().getX());
            getConfig().set(str + "y", p.getLocation().getY());
            getConfig().set(str + "z", p.getLocation().getZ());
            getConfig().set(str + "yaw", p.getLocation().getYaw());
            getConfig().set(str + "pitch", p.getLocation().getPitch());
            p.getWorld().setSpawnLocation(p.getLocation().getBlockX(), p.getLocation().getBlockZ(), p.getLocation().getBlockY());
            saveConfig();
            sender.sendMessage("§f[§c消息§f] §a成功设置§e"+worldName+"§a的复活点.");
        }
        return false;
    }

    public static Location TpSpawn(String worlName) {
        Location loc = null;
            FileConfiguration yml = Main.plugin.getConfig();
            String str = "WorldSpawn." + worlName + ".";
            if (yml.getString(str) != null) {
                String w = yml.getString(str + "world");
                double x = yml.getDouble(str + "x");
                double y = yml.getDouble(str + "y");
                double z = yml.getDouble(str + "z");
                float pi = (float) yml.getDouble(str + "pitch");
                float ya = (float) yml.getDouble(str + "yaw");
                loc = new Location(Bukkit.getWorld(w), x, y, z, ya, pi);
        }
        return loc;
    }


    public static String getTime(String Format){
        Date date = Calendar.getInstance().getTime();
        SimpleDateFormat datatime = new SimpleDateFormat(Format);
        return datatime.format(date);
    }

    // 若玩家在禁止back的世界则直接复活
    @EventHandler
    public void onAutoRespawn(PlayerDeathEvent e){
        if(e.getEntity() == null){ return; }
        Player p = e.getEntity();
        Location loc = TpSpawn("hub");
        new BukkitRunnable() {
            public void run() {
                p.spigot().respawn();
                p.teleport(loc);
            }
        }.runTaskLater(this, 5L);
    }
}